#include <stdlib.h>
#include <windows.h>
#include <stdio.h>

HANDLE GetSerialPort(char *);

int main(void)
{
    HANDLE h1;
    char h1_buffer[] = ("Hello from Com1:");
    char h2_buffer[24];
    DWORD byteswritten = 0, bytesread = 0;
    char c1[] = {"COM3"};
    int  i = 0;
    h1 = GetSerialPort(c1);

    printf("writing\n");
    WriteFile(h1, h1_buffer, 17, &byteswritten, NULL);
    printf("reading\n");
    ReadFile(h1, h2_buffer, strlen(h1_buffer) + 1, &bytesread, NULL);

    if (bytesread)
    {
        while (i < strlen(h1_buffer) && h2_buffer[i] != -32)
        {
            printf("[%d]",h2_buffer[i]);
        }
    }
    else
        printf("Nothing read\n");

    CloseHandle(h1);

    getch();
}

HANDLE GetSerialPort(char *p)
{
    HANDLE hSerial;
    hSerial = CreateFile(p,
                         GENERIC_READ | GENERIC_WRITE,
                         0,
                         0,
                         OPEN_EXISTING,
                         FILE_ATTRIBUTE_NORMAL,
                         0);

    DCB dcbSerialParams = {0};
    dcbSerialParams.DCBlength=sizeof(dcbSerialParams);
    dcbSerialParams.BaudRate=CBR_19200;
    dcbSerialParams.ByteSize=8;
    dcbSerialParams.StopBits=ONESTOPBIT;
    dcbSerialParams.Parity=NOPARITY;
    SetCommState(hSerial, &dcbSerialParams);
    return hSerial;
}
